Palindrome (POJ - 3974 ,字符串 Hash + 二分 || Manacher)

2024-03-30 13:58

本文主要是介绍Palindrome (POJ - 3974 ,字符串 Hash + 二分 || Manacher),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

一.题目链接

POJ-3974

二.题目大意:

求 s 的最大回文子串长度.

三.分析:

此题可以用 字符串 Hash + 二分 或者是 Manacher 算法.(后者明显比前者块)

由于这是 Manacher 的模板题,所以这里只讲第一种方法.

O(N)扫描字符串 s,建立前缀与后缀 Hash 数组.

之后枚举回文串的中心位置,二分答案即可.

ps:要分别处理奇偶长度的回文串.

O(nlogn) 的算法,Manacher 的时间复杂度为 O(n),但用时 Manacher 完胜第一种.

四.代码实现:

字符串 Hash + 二分

#include <set>
#include <map>
#include <ctime>
#include <queue>
#include <cmath>
#include <stack>
#include <bitset>
#include <vector>
#include <cstdio>
#include <sstream>
#include <cstring>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#define eps 1e-8
#define lc k * 2
#define rc k * 2 + 1
#define pi acos(-1.0)
#define ll long long
#define ull unsigned long long
using namespace std;const int M = (int)1e6;
const int mod = 99991;
const int inf = 0x3f3f3f3f;char s[M + 5];
ull P[M + 5];
ull prefix[M + 5];
ull suffix[M + 5];void get_sum(int len)
{P[0] = 1;suffix[len + 1] = 0;for(int i = 1; i <= len; ++i){prefix[i] = prefix[i - 1] * 131 + s[i] - 'a' + 1;P[i] = P[i - 1] * 131;}for(int i = len; i; --i)suffix[i] = suffix[i + 1] * 131 + s[i] - 'a' + 1;
}ull get_prefix(int l, int r)
{return prefix[r] - prefix[l - 1] * P[r - l + 1];
}ull get_suffix(int l, int r)
{return suffix[l] - suffix[r + 1] * P[r - l + 1];
}int solve()
{int len = strlen(s + 1);get_sum(len);int ans = 0, l, r, mid;for(int i = 1; i <= len; ++i){l = 0;r = min(i - 1, len - i);while(l < r){mid = (l + r + 1) >> 1;if(get_prefix(i - mid, i - 1) == get_suffix(i + 1, i + mid))l = mid;elser = mid - 1;}ans = max(ans, 2 * r + 1);l = 0;r = min(i, len - i);while(l < r){mid = (l + r + 1) >> 1;if(get_prefix(i - mid + 1, i) == get_suffix(i + 1, i + mid))l = mid;elser = mid - 1;}ans = max(ans, r * 2);}return ans;
}int main()
{int ca = 0;while(~scanf("%s", s + 1) && strcmp(s + 1, "END"))printf("Case %d: %d\n", ++ca, solve());return 0;
}

Manacher

#include <set>
#include <map>
#include <ctime>
#include <queue>
#include <cmath>
#include <stack>
#include <bitset>
#include <vector>
#include <cstdio>
#include <sstream>
#include <cstring>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#define eps 1e-8
#define lc k * 2
#define rc k * 2 + 1
#define pi acos(-1.0)
#define ll long long
#define ull unsigned long long
using namespace std;const int M = (int)1e6;
const int mod = 99991;
const int inf = 0x3f3f3f3f;char s[M + 5];
int P[2 * M + 5];
char res[2 * M + 5];int Manacher()
{int len = strlen(s);res[0] = '$', res[1] = '#';for(int i = 0; i < len; ++i){res[(i + 1) * 2] = s[i];res[(i + 1) * 2 + 1] = '#';}len = 2 * len + 1;res[len + 1] = '\0';int right = 0, mid = 0;int MaxLen = 0, MaxMid = 0;for(int i = 1; i <= len; ++i){P[i] = (right > i ? min(P[2 * mid - i], right - i) : 1);while(res[i + P[i]] == res[i - P[i]])P[i]++;if(right < i + P[i]){mid = i;right = i + P[i];}if(MaxLen < P[i]){MaxMid = i;MaxLen = P[i];}}return MaxLen - 1;
}int main()
{int ca = 0;while(~scanf("%s", s) && strcmp(s, "END"))printf("Case %d: %d\n", ++ca, Manacher());return 0;
}

 

这篇关于Palindrome (POJ - 3974 ,字符串 Hash + 二分 || Manacher)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/861674

相关文章

学习hash总结

2014/1/29/   最近刚开始学hash,名字很陌生,但是hash的思想却很熟悉,以前早就做过此类的题,但是不知道这就是hash思想而已,说白了hash就是一个映射,往往灵活利用数组的下标来实现算法,hash的作用:1、判重;2、统计次数;

hdu1043(八数码问题,广搜 + hash(实现状态压缩) )

利用康拓展开将一个排列映射成一个自然数,然后就变成了普通的广搜题。 #include<iostream>#include<algorithm>#include<string>#include<stack>#include<queue>#include<map>#include<stdio.h>#include<stdlib.h>#include<ctype.h>#inclu

康拓展开(hash算法中会用到)

康拓展开是一个全排列到一个自然数的双射(也就是某个全排列与某个自然数一一对应) 公式: X=a[n]*(n-1)!+a[n-1]*(n-2)!+...+a[i]*(i-1)!+...+a[1]*0! 其中,a[i]为整数,并且0<=a[i]<i,1<=i<=n。(a[i]在不同应用中的含义不同); 典型应用: 计算当前排列在所有由小到大全排列中的顺序,也就是说求当前排列是第

hdu1496(用hash思想统计数目)

作为一个刚学hash的孩子,感觉这道题目很不错,灵活的运用的数组的下标。 解题步骤:如果用常规方法解,那么时间复杂度为O(n^4),肯定会超时,然后参考了网上的解题方法,将等式分成两个部分,a*x1^2+b*x2^2和c*x3^2+d*x4^2, 各自作为数组的下标,如果两部分相加为0,则满足等式; 代码如下: #include<iostream>#include<algorithm

hdu2241(二分+合并数组)

题意:判断是否存在a+b+c = x,a,b,c分别属于集合A,B,C 如果用暴力会超时,所以这里用到了数组合并,将b,c数组合并成d,d数组存的是b,c数组元素的和,然后对d数组进行二分就可以了 代码如下(附注释): #include<iostream>#include<algorithm>#include<cstring>#include<stack>#include<que

hdu2289(简单二分)

虽说是简单二分,但是我还是wa死了  题意:已知圆台的体积,求高度 首先要知道圆台体积怎么求:设上下底的半径分别为r1,r2,高为h,V = PI*(r1*r1+r1*r2+r2*r2)*h/3 然后以h进行二分 代码如下: #include<iostream>#include<algorithm>#include<cstring>#include<stack>#includ

usaco 1.2 Milking Cows(类hash表)

第一种思路被卡了时间 到第二种思路的时候就觉得第一种思路太坑爹了 代码又长又臭还超时!! 第一种思路:我不知道为什么最后一组数据会被卡 超时超了0.2s左右 大概想法是 快排加一个遍历 先将开始时间按升序排好 然后开始遍历比较 1 若 下一个开始beg[i] 小于 tem_end 则说明本组数据与上组数据是在连续的一个区间 取max( ed[i],tem_end ) 2 反之 这个

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M